
if Allhugsinit return end


rawset(_G, "Allhugs", {})
rawset(_G, "Hugbutton", {})
rawset(_G, "Heartbutton", {})
rawset(_G, "Hugsound", {})
rawset(_G, "Yelpsound", {})
rawset(_G, "Tailshug", {})
rawset(_G, "Hearticon", {})
rawset(_G, "Loveparticle", {})
rawset(_G, "InvalidState", {})



InvalidState[S_PLAY_RIDE] = true
InvalidState[S_PLAY_STUN] = true
InvalidState[S_PLAY_PAIN] = true
InvalidState[S_PLAY_DEAD] = true
InvalidState[S_PLAY_DRWN] = true


local allowhugs = CV_RegisterVar({
	name = "allowhugs",
	defaultvalue = "on",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
})

local grouphug = CV_RegisterVar({
	name = "grouphug",
	defaultvalue = "on",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
})

local enemyhug = CV_RegisterVar({
	name = "enemyhug",
	defaultvalue = "off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
})
local launchhug = CV_RegisterVar({
	name = "launchhug",
	defaultvalue = "off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
})


-- Heart object definition
freeslot("S_PLAY_ALLHUG", "S_COLORHEART", "SPR2_IHUG", "SPR_RHRT", "SPR2_NHUG")

local everyonehugs = false

states[S_PLAY_ALLHUG] = {SPR_PLAY, A|SPR2_IHUG|FF_ANIMATE, 12, nil, 3, 4, S_PLAY_ALLHUG}

states[S_COLORHEART] = {
	sprite = SPR_RHRT,
	tics = -1
}


-- Love is in the air!
local function SpawnHearts(player)
	local heart = P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.height, (Loveparticle[player.mo.skin] or MT_CDLHRT))
	heart.destscale = (5*player.mo.scale)>>4
	heart.fuse = (5*TICRATE)>>1
	heart.momz = player.mo.scale
	heart.target = player.mo
	heart.extravalue1 = player.mo.x
	heart.extravalue2 = player.mo.y
end


-- Let's find the closest person to hug!
local function FindHugCandidates(rosy)
	local huggable
	
	for p in players.iterate
		-- Don't hug yourself
		if p == rosy continue end
		
		-- Hug only living players
		if not p.mo continue end
		if p.playerstate != PST_LIVE continue end
		
		-- No hugging in NiGHTS
		if p.powers[pw_carry] == CR_NIGHTSMODE continue end
		
		-- It's another Rosy and she's not hugging you
		if not grouphug.value then
			if p.hugging and rosy.hugged != p continue end
		end
		
		
		-- No hugging the enemy
		if not enemyhug.value then
			if p.ctfteam != rosy.ctfteam continue end
		end
		
		--Don't hug in midair
		if not (P_IsObjectOnGround(rosy.mo)) continue end	
		
		
		-- Can't hug if not on the floor or doing anything
		if not(P_IsObjectOnGround(p.mo) and (p.panim == PA_IDLE or p.panim == PA_WALK or p.panim == PA_RUN or p.panim == PA_DASH or p.panim == PA_EDGE
		or p.hugging))
			continue end
		
		

		
		-- Too high or too low to hug
		if abs(rosy.mo.z - p.mo.z) > 4*FRACUNIT continue end
		
		-- Too far away
		local dist = R_PointToDist2(rosy.mo.x, rosy.mo.y, p.mo.x, p.mo.y)
		if dist > rosy.mo.radius + p.mo.radius continue end
		
		-- Update the most likely candidate
		if not huggable or (huggable and dist < huggable.dist)
			huggable = p
			huggable.dist = dist
		end
	end
	
	return huggable
end

local function ReleaseHug(p)
	if p.hugging -- We're hugging
		p.ishugging = true
		-- Do this to me
		p.pflags = $ & ~PF_STASIS
		if not InvalidState[p.mo.state] == true
			p.mo.state = S_PLAY_STND
		end
		-- Do this to them
		if p.hugging.valid
			p.hugging.pflags = $ & ~PF_STASIS
			p.hugging.hugged = nil
		end
		
		p.hugging = nil
		
	 
	elseif p.hugged -- We're being hugged
		-- Do this for me
		p.pflags = $ & ~PF_STASIS
		
		-- Do this to them
		p.launchtimer = 3
		
		p.hugged = nil
	end
end

local function LaunchRelease(p)
		if p.valid
			p.pflags = $ & ~PF_STASIS
			--p.mo.angle = R_PointToAngle2(p.mo.x, p.mo.y, p.mo.x, p.mo.y)
			p.drawangle = p.mo.angle
			p.mo.state = S_PLAY_PAIN
			
			if p.hugtime > 1*TICRATE
				-- That's enough hugging
				if Allhugs[p.mo.skin] == true
					if p.powers[pw_super]
						p.mo.sprite2 = SPR2_NHUG|FF_SPR2SUPER
						p.mo.frame = A
						p.thrown = true
						if Tailshug[p.mo.skin] == true
							p.followmobj.flags2 = $|MF2_DONTDRAW
						end
					else
						p.mo.sprite2 = SPR2_NHUG
						p.mo.frame = A
						p.thrown = true
						if Tailshug[p.mo.skin] == true
							p.followmobj.flags2 = $|MF2_DONTDRAW
						end
					end
				else
					p.mo.sprite2 = SPR2_TRNS
					p.mo.frame = G
					p.thrown = true	
				end
			else
				-- Ouch!
				if p.powers[pw_super]
					p.mo.sprite2 = SPR2_PAIN|FF_SPR2SUPER
				else
					p.mo.sprite2 = SPR2_PAIN
				end
				S_StartSound(p.mo, (Yelpsound[p.mo.skin] or sfx_cdpcm7))
			end
			
			-- Fling Amy
			A_DoNPCPain(p.mo)
			
			p.hugging = nil
			
			if launchhug.value then
				p.launchtimer = 3
			else
				p.jumprelease = 3
			end
		end
end
	

-- Release!
local function UnhugEveryone()
	for p in players.iterate
		if p.hugging
			ReleaseHug(p)
		end
	end
end


addHook("MapLoad", UnhugEveryone)



addHook("PlayerThink", function(p)
	if not allowhugs.value
		UnhugEveryone()
		return end
	
	local rosy = p

	-- Unhug stuff


	if rosy.hugging
		if rosy.hugging.jumprelease == 1
			ReleaseHug(rosy)
			return
		end
		
		if rosy.hugging.launchtimer == 1
			LaunchRelease(rosy)
			return
		end
	end
	
	 -- Unhug when in a invalid state
	 
	 if InvalidState[p.mo.state] == true then
		if p.hugging
			ReleaseHug(p)
		end
		if not p.jumprelease
			if not p.launchtimer
				p.jumprelease = 3
			end
		end
	 end
	
	
	rosy.jumprelease = $ and $ - 1 or 0
	rosy.launchtimer = $ and $ - 1 or 0

	-- Curl when you're falling from being thrown
	if rosy.thrown and rosy.mo.momz < 0
		if Allhugs[rosy.mo.skin] == true
			if rosy.powers[pw_super]
				rosy.mo.sprite2 = SPR2_NHUG|FF_SPR2SUPER
				rosy.mo.frame = B
				rosy.thrown = false
					if Tailshug[rosy.mo.skin] == true
						rosy.tailsgone = true
						rosy.followmobj.flags2 = $|MF2_DONTDRAW
					end
			else
				rosy.mo.sprite2 = SPR2_NHUG
				rosy.mo.frame = B
				rosy.thrown = false
				if Tailshug[rosy.mo.skin] == true
					rosy.tailsgone = true
					rosy.followmobj.flags2 = $|MF2_DONTDRAW
				end
			end
		else
			rosy.mo.sprite2 = SPR2_ROLL
			rosy.mo.frame = D
			rosy.thrown = false			
			
		end
	end

	if not p.mo return end
	
	if Allhugs[p.mo.skin] != true
		if p.hug ReleaseHug(p) end --is currently not set to p.hugging to prevent other mods from breaking
		
		return
	end	

	

	-- Hug delay ticker
	
	if rosy.mo.state == S_PLAY_ALLHUG
		then rosy.hugdelay = 35
		rosy.releasedelay = $ and $ - 1 or 0
	else
		rosy.hugdelay = $ and $ - 1 or 0
		rosy.releasedelay = 35
	end

	
	

	
	
	if Tailshug[rosy.mo.skin] == true
		if rosy.mo.eflags & MFE_JUSTHITFLOOR
			if rosy.tailsgone == true
				rosy.followmobj.flags2 = $&~MF2_DONTDRAW
				rosy.tailsgone = false
			end
		end
	end

    
	 


	-- Hug thinker ~
	if rosy.hugging
		if not rosy.hugging.valid
			ReleaseHug(rosy)
			return
		end
		

		
		
		rosy.hugging.pflags = $ | PF_STASIS	
		rosy.pflags = $ | PF_STASIS
		rosy.target = rosy.hugging
		rosy.drawangle = rosy.hugangle
		if rosy.mo.state ~= S_PLAY_ALLHUG
			rosy.mo.state = S_PLAY_ALLHUG
		end
		rosy.hugtime = $ + 1
		
		if  rosy.hugging  --Hug back! This is a war of affection!
		and rosy.hugging.cmd.buttons & (Hugbutton[rosy.mo.skin] or BT_CUSTOM2) and not rosy.hugging.hugdelay
			if not (rosy.hugging.mo.state == S_PLAY_ALLHUG)	
					rosy.hugged = rosy.hugging
					rosy.hugging.hugging = rosy
					rosy.hugging.hugtime = 0
					rosy.hugging.hugangle = R_PointToAngle2(rosy.hugging.mo.x, rosy.hugging.mo.y, rosy.mo.x, rosy.mo.y)
					S_StartSound(rosy.hugging.mo, (Hugsound[rosy.mo.skin] or sfx_cdpcm6))
			end
		end		
		
		if rosy.cmd.buttons & (Hugbutton[rosy.mo.skin] or BT_CUSTOM2) and not rosy.releasedelay
			ReleaseHug(rosy)
		elseif rosy.cmd.buttons & (Heartbutton[rosy.mo.skin] or BT_CUSTOM3)
			if not (leveltime & 7)
				SpawnHearts(rosy)
			end
		end
		
		return
	end
	
	local cand = FindHugCandidates(rosy)
	
	-- We don't have candidates? Get rid of the heart
	if not cand
		if rosy.heart and rosy.heart.valid
			P_RemoveMobj(rosy.heart)
		end
		
		rosy.heart = nil
		return
	end
	
	-- Found someone? Place the heart indicator
	if not rosy.heart 
		rosy.heart = P_SpawnMobjFromMobj(cand.mo, 0, 0, cand.mo.height + 24*cand.mo.scale, MT_LOCKON)
		rosy.heart.state = (Hearticon[rosy.mo.skin] or S_COLORHEART)
		rosy.heart.color = rosy.mo.color
		rosy.heart.scale = 2*cand.mo.scale/3
		rosy.heart.fuse = -1
		rosy.heart.tracer = rosy.mo
		rosy.heart.target = cand.mo
	end
	
	-- Hug!
	if rosy.cmd.buttons & (Hugbutton[rosy.mo.skin] or BT_CUSTOM2) and not rosy.hugdelay
	and not (rosy.pflags & PF_STASIS)
	and not (rosy.pflags & PF_FULLSTASIS)
		rosy.mo.momx = 0
		rosy.mo.momy = 0
		
		cand.hugged = rosy
		rosy.hugging = cand
		
		rosy.hugtime = 0
		rosy.hugangle = R_PointToAngle2(rosy.mo.x, rosy.mo.y, cand.mo.x, cand.mo.y)
		
		-- Ufufu~
		S_StartSound(rosy.mo, (Hugsound[rosy.mo.skin] or sfx_cdpcm6))
	end

	
	
end)

addHook("MobjThinker", function(mo)
	if mo and mo.tracer
		if Allhugs[mo.tracer.skin] != true or mo.tracer.player.hugging
			mo.tracer.heart = nil
			P_RemoveMobj(mo)
			return
		else
			mo.color = mo.tracer.color
			mo.scale = 2*mo.target.scale/3
			
			local bob = 5 * sin(FixedAngle(leveltime*FRACUNIT*3))
			
			P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z + mo.target.height + 15 * mo.scale + FixedMul(bob, mo.scale))
			return true
		end
	elseif mo.state == S_COLORHEART
		P_RemoveMobj(mo)
	end
end, MT_LOCKON)

addHook("JumpSpecial", function(p)
	ReleaseHug(p)
end)

rawset (_G, "Allhugsinit", {})
--Branch of Everyonehugs by Tatsuru
--Thanks to amberbee for the idea of a seperate file for the hug tables
--Lua changes by Csean07, KirbyDL, & Astral
--New Sprites by Ironskarmory676 & Zeval/RosaNova